import java.util.*;

// The 'Invoker' class

  public class User{
    private Calculator _calculator = new Calculator();
    private List<Command> _commands = new ArrayList<Command>();
    private int _current = 0;

    public void redo(int levels){

      System.out.println("\n---- Redo " + levels + " levels ");

      // Perform redo operations
      for (int i = 0; i < levels; i++){

        if (_current < _commands.size() )
        {
          Command command = (Command) _commands.get(_current++);
          command.execute();
        }
      }
    }
 

    public void undo(int levels){

      System.out.println("\n---- Undo " + levels + " levels ");

      // Perform undo operations
      for (int i = 0; i < levels; i++){

        if (_current > 0){

          Command command = (Command) _commands.get(--_current);
          command.unExecute();

        }
      }
    }

 

    public void compute(char operator, int operand)

    {

      // Create command operation and execute it

      Command command = new CalculatorCommand( _calculator, operator, operand);

      command.execute();

       // Add command to undo list

      System.out.println(_commands.add(command));

      _current++;

    }

  public void printtt(){
      for (Command c : _commands)
          c.printtt();
        }
}